import { GlobalState } from '@app/core/state';
import { createSelector } from '@ngrx/store';
import { DARSState } from './state';

export const getDARSState = ({ dars }: GlobalState) => {
  return dars;
};

export const metadataStatus = createSelector(
  getDARSState,
  (state: DARSState) => state.metadata.status,
);

export const programMetadata = createSelector(
  getDARSState,
  (state: DARSState) => {
    if (state.metadata.status === 'Loaded') {
      return state.metadata.programMetadata;
    } else {
      return [];
    }
  },
);

export const whatIfMetadata = createSelector(
  getDARSState,
  (state: DARSState) => {
    if (state.metadata.status === 'Loaded') {
      return state.metadata.whatIfMetadata;
    } else {
      return [];
    }
  },
);

export const visibleAuditStatus = createSelector(
  getDARSState,
  (state: DARSState) => state.visibleAudit.status,
);

export const visibleAudit = createSelector(
  getDARSState,
  (state: DARSState) =>
    state.visibleAudit.status === 'Loaded' ? state.visibleAudit.audit : null,
);
